/*
 * MiniGUI 'Table of Colors' Demo
 * http://www.hmgforum.com/viewtopic.php?t=2076
 * http://www.hmgforum.com/viewtopic.php?f=8&t=3953&hilit=WinVersion
 * (c) 2011 Grigory Filatov <gfilatov@inbox.ru>
 * 2019 Modified By Mustafa Lpez  Alicante( Spain )   
*/

#include "hmg.ch"

Static aColors

PROCEDURE MAIN 

LOCAL lInit := .f.
PRIVATE aData := {}

  FileDelete("control.mem")
   IF ! FILE("control.mem")
     nOrder := 0
     SAVE TO control.mem ALL LIKE nOrder*
   ENDIF

	SET MULTIPLE OFF
        SET TOOLTIPSTYLE BALLOON

        aEval( ( aColors := InitColorsArray() ), { |x| aAdd( aData, {  x[1] } ) } )

	DEFINE WINDOW Form_1                      ;
		AT 0,0                            ;
		WIDTH  398                        ;
		HEIGHT 620                        ;   
		TITLE 'Table of Colors'           ;
                ICON 'Logo'                       ;
                BACKCOLOR { 159,121,238 }         ;
		MAIN                              ;
		NOMAXIMIZE NOSIZE ;
                ON INIT Positione()   

                ON KEY ESCAPE ACTION Form_1.Release

		DEFINE MAIN MENU
			DEFINE POPUP '&File'
                                MENUITEM '&Show Items Count' ACTION MsgInfo( ALLTRIM( STR(Form_1.Grid_1.Value)) + " / " + ALLTRIM( STR(Form_1.Grid_1.ItemCount ) ); 
                                                                                          , "Items Count")  IMAGE "Resource\Item.bmp"   
				SEPARATOR
                                MENUITEM '&Copy to Clipboard' + Chr(9) + 'CTRL+C'  ACTION CopyClipboard()   IMAGE "Resource\Clipboard.bmp"
                                SEPARATOR
                                MENUITEM  "V&iew_Pdf"                              ACTION ViewPdf()         IMAGE 'Resource\Pdf.bmp'   
                                SEPARATOR
                                MENUITEM '&About ...'                              ACTION AboutX()          IMAGE "Resource\Home.bmp"
                                SEPARATOR
                                MENUITEM '&Exit'                                   ACTION Form_1.Release    IMAGE "Resource\Exit.bmp"

			END POPUP
		END MENU

*------------------------------------------------------------------ Search Colors ----------------------------------------------------------------*

    DEFINE TEXTBOX Text_002
        ROW    011  
        COL    017 
        WIDTH  225 
        HEIGHT 023
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Search Colors"
        ONCHANGE SearchChange_2()
        FONTBOLD .F.
        FONTITALIC .F.
        BACKCOLOR {238,210,238}
        FONTCOLOR NIL
        VALUE ""
        CASECONVERT LOWER 
    END TEXTBOX
*---------------------------------------------------------------------------------------------------------------------------------------------------*

		DEFINE GRID Grid_1
			ROW 	040 
			COL	017 
			WIDTH	359
			HEIGHT	457   
			WIDTHS	{ 350 - iif(IsAppThemed(), 2, 0) }  
			VALUE	1
		 	VIRTUAL .F.                       //.T. <----- Modified 
			ITEMCOUNT Len(aData)
			ON QUERYDATA OnDataRequest( aData )
			ON CHANGE ( ArribAbajo(),  iif( lInit, Show_RGB(), lInit := .T. ) )
                        ON DBLCLICK ( ICopy() , CopyClipboard() )   
			HEADERS {"HMG Color Name"}
			DYNAMICFORECOLOR { { |x,nItem| GetColumnForeColor( nItem ) } }
			DYNAMICBACKCOLOR { { |x,nItem| GetColumnBackColor( nItem ) } }
			FONTNAME "Verdana"
			FONTSIZE 10
		END GRID

*------------------------------------  Buttons ---> "First  Previous  Next Last "---------------------------------------------------------------------*

  DEFINE BUTTON But_01
         ROW   508 
         COL    260 
         WIDTH  030
         HEIGHT 030
         PICTURE "Resource/btn_01.bmp"  
         TOOLTIP 'First '
         ACTION  GoFirst() 
    END BUTTON

    DEFINE BUTTON But_02
         ROW    508 
         COL    288
         WIDTH  030
         HEIGHT 030
         PICTURE "Resource/btn_02.bmp"  
         TOOLTIP 'Previous'
         ACTION GoPrevious() 
    END BUTTON

    DEFINE BUTTON But_03
         ROW    508  
         COL    317 
         WIDTH  030
         HEIGHT 030
         PICTURE "Resource/btn_03.bmp"  
         TOOLTIP 'Next'
         ACTION GoNext() 
    END BUTTON

    DEFINE BUTTON But_04
         ROW    508  
         COL    347 
         WIDTH  030
         HEIGHT 030
         PICTURE "Resource/btn_04.bmp"  
         TOOLTIP 'Last'
         ACTION GoLast() 
    END BUTTON

*--------------------------------------------------------------------------------------*

   DEFINE BUTTON But_05
        ROW    007 
        COL    270 
        WIDTH  105
        HEIGHT 028
        ACTION Cleany()
        CAPTION  SPACE(06)-"Clean" 
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Clean Search"
        FONTBOLD .T.
        FONTITALIC .T.
        PICTURE "Resource\Clean.bmp"
        PICTALIGNMENT  LEFT
    END BUTTON

    DEFINE BUTTON But_06
          ROW    508 
          COL    018
          WIDTH  105
          HEIGHT 030
          ACTION  thiswindow.release   
          CAPTION SPACE(5)-"Exit"
          FONTNAME "Arial"
          FONTSIZE 9
          TOOLTIP "Exit"
          FONTBOLD .T.
          FONTITALIC .T.
          PICTURE "Resource/Exit.Bmp"
          PICTALIGNMENT LEFT
    END BUTTON

    @ 514, 134 Label Label_1G               ;    
                width   053                 ;
                height  027                 ;  
                FONT "Arial"  SIZE 10 BOLD  ;
                FONTCOLOR { 000, 000, 000 } ;
                BACKCOLOR { 159, 121, 238 } ;       
                VALUE "Records:"  
     
     @ 514, 198 Label Label_2G              ;     
                width   058                 ;
                height  027                 ;  
                FONT "Arial"  SIZE 10 BOLD  ;
                FONTCOLOR { 000, 000, 000 } ;
                BACKCOLOR { 159, 121, 238 } ;      
                VALUE ""  

		DEFINE STATUSBAR FONT "MS Sans serif" SIZE 9 BOLD
		       STATUSITEM SPACE(3)+ " Value RGB: " + aColors [ 1 ] [ 2 ] + SPACE(2)+ "Color :"+SPACE(1)+ aColors [ 1 ] [ 1 ] 
		END STATUSBAR

       ON KEY CONTROL+C ACTION CopyClipboard()

       Chane_Style() 

   END WINDOW
 
   SETWINDOWCURSOR ( Form_1.But_04.Handle , "Resource\SmoothHand.cur")

   Form_1.Text_002.SetFocus
   Form_1.Grid_1.Refresh

      CENTER WINDOW Form_1
      ACTIVATE WINDOW Form_1

Return Nil


*********************************************************************************************************************

*---------------------------------------------------------*
 FUNCTION Cleany()
*---------------------------------------------------------*
   Form_1.Text_002.Value :=""
   Form_1.Text_002.SetFocus
   GoFirst()

Return Nil

*---------------------------------------------------------*
 FUNCTION ArribAbajo()      // Cuenta Registros
*---------------------------------------------------------*

   Form_1.Label_2G.Value :=  ALLTRIM( STR(Form_1.Grid_1.Value)) + " / " + ALLTRIM( STR(Form_1.Grid_1.ItemCount ))           

Return Nil 	              

*---------------------------------------------------------* 
  Function Chane_Style()   // Hace Recuadro en Grid_1
*---------------------------------------------------------* 

 HMG_ChangeWindowStyle ( GetControlHandle("Grid_1","Form_1"), LVS_REPORT, NIL, .T. )

Return

*---------------------------------------------------------*
 Function Positione()     // Initius Colors Grid
*---------------------------------------------------------*

Form_1.Grid_1.DeleteAllItems

For i := 1 To Len(aData)        
         Form_1.Grid_1.AddItem ( aData [ i ] )
Next

  GoFirst()
  ArribAbajo()

Return Nil

*---------------------------------------------------------*
 Function GoFirst()
*---------------------------------------------------------*
Form_1.Text_002.Value := ""
Form_1.Grid_1.Value :=  1  
Show_RGB()
Form_1.Grid_1.Refresh

Return Nil

*---------------------------------------------------------*
 Function GoPrevious()
*---------------------------------------------------------*
LOCAL nPos , nposx

Form_1.Text_002.Value := ""
npos:= Form_1.Grid_1.Value  
nposx=npos-1
Form_1.Grid_1.Value := nposx
Show_RGB()
Form_1.Grid_1.Refresh
	
Return Nil
	
*---------------------------------------------------------*
 Function GoNext()
*---------------------------------------------------------*
LOCAL nPos , nposx

Form_1.Text_002.Value := ""
npos:= Form_1.Grid_1.Value  
nposx=npos+1
Form_1.Grid_1.Value := nposx
Show_RGB()
Form_1.Grid_1.Refresh
	
Return Nil

*---------------------------------------------------------*
Function GoLast()
*---------------------------------------------------------*
LOCAL ultim

Form_1.Text_002.Value := ""
ultim := Len(aData)
Form_1.Grid_1.Value := ultim 
Show_RGB()
Form_1.Grid_1.Refresh

Return Nil

******************************************************************************************************************

*---------------------------------------------------------*
 Procedure SearchChange_2()   // Searchs Nom Colors
*---------------------------------------------------------*

LOCAL  cTxtQ, nLen, i , miry0 , miry1 

cTxtQ := GetProperty( 'Form_1','Text_002','Value' )
nLen  := Len( cTxtQ )

Form_1.Grid_1.DeleteAllItems

For i := 1 To Len(aData)  
           IF Upper( cTxtQ ) = Upper( Left(aData [ i ] [ 1] , nLen ) )  
              Form_1.Grid_1.AddItem ( aData [ i ] )
              Form_1.Grid_1.CellEx (i, 2) 
          ENDIF 
Next

Return Nil

*---------------------------------------------------------*
 Procedure ICopy()
*---------------------------------------------------------*
 nOrder := 1
 SAVE TO control.mem ALL LIKE nOrder*

Return Nil

*---------------------------------------------------------*
 Procedure CopyClipboard()
*---------------------------------------------------------*

 LOCAL cText , nRow , miry0 , miry1 , niscus

   RESTORE FROM control.mem ADDITIVE
   
  IF  nOrder == 0
      nOrder := 1
      SAVE TO control.mem ALL LIKE nOrder*
      GoFirst()
      CopyClipboard()
      Return(.F.)
  ELSE
      nOrder := 1
      SAVE TO control.mem ALL LIKE nOrder*

      nRow   := Form_1.Grid_1.CellRowFocused  
      miry0  := aColors [ Form_1.Grid_1.Value ] [ 2 ]
      miry1  := STRTRAN( miry0 , " " ,  "," )    

   IF nRow > 0
      niscus := ALLTRIM( STR(Form_1.Grid_1.Value))
      cText  := Form_1.Grid_1.CellEx (nRow, 1)
      System.Clipboard  := '{ ' + miry1  + ' }'                
      MsgInfo ( "Value RGB: { " + miry1  + " } " + CRLF + CRLF +;
                "Color :"+ SPACE(3) + cText      + CRLF + CRLF +;
                "Record:"+ SPACE(3) + niscus ,"Copy to Clipboard")

   ENDIF
        
ENDIF

Return nIL

*---------------------------------------------------------*
 Procedure OnDataRequest( aData )
*---------------------------------------------------------*

 This.QueryData := aData [ This.QueryRowIndex ] [ 1 ]

Return

*---------------------------------------------------------*
 Procedure Show_RGB()
*---------------------------------------------------------*

 Form_1.StatusBar.Item( 1 ) := SPACE(3)+" Value RGB: " + aColors [ Form_1.Grid_1.Value ] [ 2 ] + SPACE(2)+ "Color :"+SPACE(1)+ aColors [ Form_1.Grid_1.Value ] [ 1 ] 

Return

*---------------------------------------------------------*
 Function GetColumnForeColor( n )
*---------------------------------------------------------*

Local aColor

 n := This.CellRowIndex 

 Switch n
   case 27
     aColor := WHITE
     exit
   case 28
   case 34
   case 35
   case 61
   case 62
   case 99
   case 100
   case 184
   case 187
   case 188
   case 189
   case 190
   case 191
   case 192
   case 195
   case 196
   case 200
   case 204
   case 208
   case 220
   case 260
   case 268
   case 272
   case 320
   case 324
   case 336
   case 340
   case 344
   case 348
   case 352
   case 356
   case 360
   case 364
   case 368
   case 372
   case 376
   case 380
   case 384
   case 388
   case 392
   case 396
   case 400
   case 404
   case 408
   case 412
   case 416
   case 424
   case 428
   case 432
   case 436
   case 441
   case 442
   case 443
   case 444
   case 445
   case 451
   case 452
   case 453
   case 454
     aColor := YELLOW
     exit
   otherwise
     aColor := BLACK
 EndSwitch

Return aColor

*---------------------------------------------------------*
 Function GetColumnBackColor( n )
*---------------------------------------------------------*
LOCAL cColor

 n := This.CellRowIndex 

 cColor := aColors [ n ] [ 2 ]

Return { Val( Token( cColor, " ", 1 ) ), Val( Token( cColor, " ", 2 ) ), Val( Token( cColor, " ", 3 ) ) }

*---------------------------------------------------------*
 Function GetHeaderForeColor( n )
*---------------------------------------------------------*
Local cColor := aColors [ n ] [ 2 ]

Return { Val( Token( cColor, " ", 1 ) ), Val( Token( cColor, " ", 2 ) ), Val( Token( cColor, " ", 3 ) ) }

*---------------------------------------------------------*
Static Function InitColorsArray()
*---------------------------------------------------------*
Local aClrData := { ;
 {"Snow",                 "255 250 250"} ,;
 {"GhostWhite",           "248 248 255"} ,;
 {"WhiteSmoke",           "245 245 245"} ,;
 {"Gainsboro",            "220 220 220"} ,;
 {"FloralWhite",          "255 250 240"} ,;
 {"OldLace",              "253 245 230"} ,;
 {"Linen",                "250 240 230"} ,;
 {"AntiqueWhite",         "250 235 215"} ,;
 {"PapayaWhip",           "255 239 213"} ,;
 {"BlanchedAlmond",       "255 235 205"} ,;
 {"Bisque",               "255 228 196"} ,;
 {"PeachPuff",            "255 218 185"} ,;
 {"NavajoWhite",          "255 222 173"} ,;
 {"Moccasin",             "255 228 181"} ,;
 {"Cornsilk",             "255 248 220"} ,;
 {"Ivory",                "255 255 240"} ,;
 {"LemonChiffon",         "255 250 205"} ,;
 {"Seashell",             "255 245 238"} ,;
 {"Honeydew",             "240 255 240"} ,;
 {"MintCream",            "245 255 250"} ,;
 {"Azure",                "240 255 255"} ,;
 {"AliceBlue",            "240 248 255"} ,;
 {"Lavender",             "230 230 250"} ,;
 {"LavenderBlush",        "255 240 245"} ,;
 {"MistyRose",            "255 228 225"} ,;
 {"White",                "255 255 255"} ,;
 {"Black",                "000 000 000"} ,;
 {"DarkSlateGray",        "047 079 079"} ,;
 {"DimGrey",              "105 105 105"} ,;
 {"SlateGrey",            "112 128 144"} ,;
 {"LightSlateGray",       "119 136 153"} ,;
 {"Grey",                 "190 190 190"} ,;
 {"LightGray",            "211 211 211"} ,;
 {"MidnightBlue",         "025 025 112"} ,;
 {"NavyBlue (Navy)",      "000 000 128"} ,;
 {"CornflowerBlue",       "100 149 237"} ,;
 {"DarkSlateBlue",        "072 061 139"} ,;
 {"SlateBlue",            "106 090 205"} ,;
 {"MediumSlateBlue",      "123 104 238"} ,;
 {"LightSlateBlue",       "132 112 255"} ,;
 {"MediumBlue",           "000 000 205"} ,;
 {"RoyalBlue",            "065 105 225"} ,;
 {"Blue",                 "000 000 255"} ,;
 {"DodgerBlue",           "030 144 255"} ,;
 {"DeepSkyBlue",          "000 191 255"} ,;
 {"SkyBlue",              "135 206 235"} ,;
 {"LightSkyBlue",         "135 206 250"} ,;
 {"SteelBlue",            "070 130 180"} ,;
 {"LightSteelBlue",       "176 196 222"} ,;
 {"LightBlue",            "173 216 230"} ,;
 {"PowderBlue",           "176 224 230"} ,;
 {"PaleTurquoise",        "175 238 238"} ,;
 {"DarkTurquoise",        "000 206 209"} ,;
 {"MediumTurquoise",      "072 209 204"} ,;
 {"Turquoise",            "064 224 208"} ,;
 {"Cyan",                 "000 255 255"} ,;
 {"LightCyan",            "224 255 255"} ,;
 {"CadetBlue",            "095 158 160"} ,;
 {"MediumAquamarine",     "102 205 170"} ,;
 {"Aquamarine",           "127 255 212"} ,;
 {"DarkGreen",            "000 100 000"} ,;
 {"DarkOliveGreen",       "085 107 047"} ,;
 {"DarkSeaGreen",         "143 188 143"} ,;
 {"SeaGreen",             "046 139 087"} ,;
 {"MediumSeaGreen",       "060 179 113"} ,;
 {"LightSeaGreen",        "032 178 170"} ,;
 {"PaleGreen",            "152 251 152"} ,;
 {"SpringGreen",          "000 255 127"} ,;
 {"LawnGreen",            "124 252 000"} ,;
 {"Green",                "000 255 000"} ,;
 {"Chartreuse",           "127 255 000"} ,;
 {"MediumSpringGreen",    "000 250 154"} ,;
 {"GreenYellow",          "173 255 047"} ,;
 {"LimeGreen",            "050 205 050"} ,;
 {"YellowGreen",          "154 205 050"} ,;
 {"ForestGreen",          "034 139 034"} ,;
 {"OliveDrab",            "107 142 035"} ,;
 {"DarkKhaki",            "189 183 107"} ,;
 {"Khaki",                "240 230 140"} ,;
 {"PaleGoldenrod",        "238 232 170"} ,;
 {"LightGoldenrodYellow", "250 250 210"} ,;
 {"LightYellow",          "255 255 224"} ,;
 {"Yellow",               "255 255 000"} ,;
 {"Gold",                 "255 215 000"} ,;
 {"LightGoldenrod",       "238 221 130"} ,;
 {"Goldenrod",            "218 165 032"} ,;
 {"DarkGoldenrod",        "184 134 011"} ,;
 {"RosyBrown",            "188 143 143"} ,;
 {"IndianRed",            "205 092 092"} ,;
 {"SaddleBrown",          "139 069 019"} ,;
 {"Sienna",               "160 082 045"} ,;
 {"Peru",                 "205 133 063"} ,;
 {"Burlywood",            "222 184 135"} ,;
 {"Beige",                "245 245 220"} ,;
 {"Wheat",                "245 222 179"} ,;
 {"SandyBrown",           "244 164 096"} ,;
 {"Tan",                  "210 180 140"} ,;
 {"Chocolate",            "210 105 030"} ,;
 {"Firebrick",            "178 034 034"} ,;
 {"Brown",                "165 042 042"} ,;
 {"DarkSalmon",           "233 150 122"} ,;
 {"Salmon",               "250 128 114"} ,;
 {"LightSalmon",          "255 160 122"} ,;
 {"Orange",               "255 165 000"} ,;
 {"DarkOrange",           "255 140 000"} ,;
 {"Coral",                "255 127 080"} ,;
 {"LightCoral",           "240 128 128"} ,;
 {"Tomato",               "255 099 071"} ,;
 {"OrangeRed",            "255 069 000"} ,;
 {"Red",                  "255 000 000"} ,;
 {"HotPink",              "255 105 180"} ,;
 {"DeepPink",             "255 020 147"} ,;
 {"Pink",                 "255 192 203"} ,;
 {"LightPink",            "255 182 193"} ,;
 {"PaleVioletRed",        "219 112 147"} ,;
 {"Maroon",               "176 048 096"} ,;
 {"MediumVioletRed",      "199 021 133"} ,;
 {"VioletRed",            "208 032 144"} ,;
 {"Magenta",              "255 000 255"} ,;
 {"Violet",               "238 130 238"} ,;
 {"Plum",                 "221 160 221"} ,;
 {"Orchid",               "218 112 214"} ,;
 {"MediumOrchid",         "186 085 211"} ,;
 {"DarkOrchid",           "153 050 204"} ,;
 {"BlueViolet",           "138 043 226"} ,;
 {"Purple",               "160 032 240"} ,;
 {"MediumPurple",         "147 112 219"} ,;
 {"Thistle",              "216 191 216"} ,;
 {"Snow1",                "255 250 250"} ,;
 {"Snow2",                "238 233 233"} ,;
 {"Snow3",                "205 201 201"} ,;
 {"Snow4",                "139 137 137"} ,;
 {"Seashell1",            "255 245 238"} ,;
 {"Seashell2",            "238 229 222"} ,;
 {"Seashell3",            "205 197 191"} ,;
 {"Seashell4",            "139 134 130"} ,;
 {"AntiqueWhite1",        "255 239 219"} ,;
 {"AntiqueWhite2",        "238 223 204"} ,;
 {"AntiqueWhite3",        "205 192 176"} ,;
 {"AntiqueWhite4",        "139 131 120"} ,;
 {"Bisque1",              "255 228 196"} ,;
 {"Bisque2",              "238 213 183"} ,;
 {"Bisque3",              "205 183 158"} ,;
 {"Bisque4",              "139 125 107"} ,;
 {"PeachPuff1",           "255 218 185"} ,;
 {"PeachPuff2",           "238 203 173"} ,;
 {"PeachPuff3",           "205 175 149"} ,;
 {"PeachPuff4",           "139 119 101"} ,;
 {"NavajoWhite1",         "255 222 173"} ,;
 {"NavajoWhite2",         "238 207 161"} ,;
 {"NavajoWhite3",         "205 179 139"} ,;
 {"NavajoWhite4",         "139 121 094"} ,;
 {"LemonChiffon1",        "255 250 205"} ,;
 {"LemonChiffon2",        "238 233 191"} ,;
 {"LemonChiffon3",        "205 201 165"} ,;
 {"LemonChiffon4",        "139 137 112"} ,;
 {"Cornsilk1",            "255 248 220"} ,;
 {"Cornsilk2",            "238 232 205"} ,;
 {"Cornsilk3",            "205 200 177"} ,;
 {"Cornsilk4",            "139 136 120"} ,;
 {"Ivory1",               "255 255 240"} ,;
 {"Ivory2",               "238 238 224"} ,;
 {"Ivory3",               "205 205 193"} ,;
 {"Ivory4",               "139 139 131"} ,;
 {"Honeydew1",            "240 255 240"} ,;
 {"Honeydew2",            "224 238 224"} ,;
 {"Honeydew3",            "193 205 193"} ,;
 {"Honeydew4",            "131 139 131"} ,;
 {"LavenderBlush1",       "255 240 245"} ,;
 {"LavenderBlush2",       "238 224 229"} ,;
 {"LavenderBlush3",       "205 193 197"} ,;
 {"LavenderBlush4",       "139 131 134"} ,;
 {"MistyRose1",           "255 228 225"} ,;
 {"MistyRose2",           "238 213 210"} ,;
 {"MistyRose3",           "205 183 181"} ,;
 {"MistyRose4",           "139 125 123"} ,;
 {"Azure1",               "240 255 255"} ,;
 {"Azure2",               "224 238 238"} ,;
 {"Azure3",               "193 205 205"} ,;
 {"Azure4",               "131 139 139"} ,;
 {"SlateBlue1",           "131 111 255"} ,;
 {"SlateBlue2",           "122 103 238"} ,;
 {"SlateBlue3",           "105 089 205"} ,;
 {"SlateBlue4",           "071 060 139"} ,;
 {"RoyalBlue1",           "072 118 255"} ,;
 {"RoyalBlue2",           "067 110 238"} ,;
 {"RoyalBlue3",           "058 095 205"} ,;
 {"RoyalBlue4",           "039 064 139"} ,;
 {"Blue1",                "000 000 255"} ,;
 {"Blue2",                "000 000 238"} ,;
 {"Blue3",                "000 000 205"} ,;
 {"Blue4",                "000 000 139"} ,;
 {"DodgerBlue1",          "030 144 255"} ,;
 {"DodgerBlue2",          "028 134 238"} ,;
 {"DodgerBlue3",          "024 116 205"} ,;
 {"DodgerBlue4",          "016 078 139"} ,;
 {"SteelBlue1",           "099 184 255"} ,;
 {"SteelBlue2",           "092 172 238"} ,;
 {"SteelBlue3",           "079 148 205"} ,;
 {"SteelBlue4",           "054 100 139"} ,;
 {"DeepSkyBlue1",         "000 191 255"} ,;
 {"DeepSkyBlue2",         "000 178 238"} ,;
 {"DeepSkyBlue3",         "000 154 205"} ,;
 {"DeepSkyBlue4",         "000 104 139"} ,;
 {"SkyBlue1",             "135 206 255"} ,;
 {"SkyBlue2",             "126 192 238"} ,;
 {"SkyBlue3",             "108 166 205"} ,;
 {"SkyBlue4",             "074 112 139"} ,;
 {"LightSkyBlue1",        "176 226 255"} ,;
 {"LightSkyBlue2",        "164 211 238"} ,;
 {"LightSkyBlue3",        "141 182 205"} ,;
 {"LightSkyBlue4",        "096 123 139"} ,;
 {"SlateGray1",           "198 226 255"} ,;
 {"SlateGray2",           "185 211 238"} ,;
 {"SlateGray3",           "159 182 205"} ,;
 {"SlateGray4",           "108 123 139"} ,;
 {"LightSteelBlue1",      "202 225 255"} ,;
 {"LightSteelBlue2",      "188 210 238"} ,;
 {"LightSteelBlue3",      "162 181 205"} ,;
 {"LightSteelBlue4",      "110 123 139"} ,;
 {"LightBlue1",           "191 239 255"} ,;
 {"LightBlue2",           "178 223 238"} ,;
 {"LightBlue3",           "154 192 205"} ,;
 {"LightBlue4",           "104 131 139"} ,;
 {"LightCyan1",           "224 255 255"} ,;
 {"LightCyan2",           "209 238 238"} ,;
 {"LightCyan3",           "180 205 205"} ,;
 {"LightCyan4",           "122 139 139"} ,;
 {"PaleTurquoise1",       "187 255 255"} ,;
 {"PaleTurquoise2",       "174 238 238"} ,;
 {"PaleTurquoise3",       "150 205 205"} ,;
 {"PaleTurquoise4",       "102 139 139"} ,;
 {"CadetBlue1",           "152 245 255"} ,;
 {"CadetBlue2",           "142 229 238"} ,;
 {"CadetBlue3",           "122 197 205"} ,;
 {"CadetBlue4",           "083 134 139"} ,;
 {"Turquoise1",           "000 245 255"} ,;
 {"Turquoise2",           "000 229 238"} ,;
 {"Turquoise3",           "000 197 205"} ,;
 {"Turquoise4",           "000 134 139"} ,;
 {"Cyan1",                "000 255 255"} ,;
 {"Cyan2",                "000 238 238"} ,;
 {"Cyan3",                "000 205 205"} ,;
 {"Cyan4",                "000 139 139"} ,;
 {"DarkSlateGray1",       "151 255 255"} ,;
 {"DarkSlateGray2",       "141 238 238"} ,;
 {"DarkSlateGray3",       "121 205 205"} ,;
 {"DarkSlateGray4",       "082 139 139"} ,;
 {"Aquamarine1",          "127 255 212"} ,;
 {"Aquamarine2",          "118 238 198"} ,;
 {"Aquamarine3",          "102 205 170"} ,;
 {"Aquamarine4",          "069 139 116"} ,;
 {"DarkSeaGreen1",        "193 255 193"} ,;
 {"DarkSeaGreen2",        "180 238 180"} ,;
 {"DarkSeaGreen3",        "155 205 155"} ,;
 {"DarkSeaGreen4",        "105 139 105"} ,;
 {"SeaGreen1",            "084 255 159"} ,;
 {"SeaGreen2",            "078 238 148"} ,;
 {"SeaGreen3",            "067 205 128"} ,;
 {"SeaGreen4",            "046 139 087"} ,;
 {"PaleGreen1",           "154 255 154"} ,;
 {"PaleGreen2",           "144 238 144"} ,;
 {"PaleGreen3",           "124 205 124"} ,;
 {"PaleGreen4",           "084 139 084"} ,;
 {"SpringGreen1",         "000 255 127"} ,;
 {"SpringGreen2",         "000 238 118"} ,;
 {"SpringGreen3",         "000 205 102"} ,;
 {"SpringGreen4",         "000 139 069"} ,;
 {"Green1",               "000 255 000"} ,;
 {"Green2",               "000 238 000"} ,;
 {"Green3",               "000 205 000"} ,;
 {"Green4",               "000 139 000"} ,;
 {"Chartreuse1",          "127 255 000"} ,;
 {"Chartreuse2",          "118 238 000"} ,;
 {"Chartreuse3",          "102 205 000"} ,;
 {"Chartreuse4",          "069 139 000"} ,;
 {"OliveDrab1",           "192 255 062"} ,;
 {"OliveDrab2",           "179 238 058"} ,;
 {"OliveDrab3",           "154 205 050"} ,;
 {"OliveDrab4",           "105 139 034"} ,;
 {"DarkOliveGreen1",      "202 255 112"} ,;
 {"DarkOliveGreen2",      "188 238 104"} ,;
 {"DarkOliveGreen3",      "162 205 090"} ,;
 {"DarkOliveGreen4",      "110 139 061"} ,;
 {"Khaki1",               "255 246 143"} ,;
 {"Khaki2",               "238 230 133"} ,;
 {"Khaki3",               "205 198 115"} ,;
 {"Khaki4",               "139 134 078"} ,;
 {"LightGoldenrod1",      "255 236 139"} ,;
 {"LightGoldenrod2",      "238 220 130"} ,;
 {"LightGoldenrod3",      "205 190 112"} ,;
 {"LightGoldenrod4",      "139 129 076"} ,;
 {"LightYellow1",         "255 255 224"} ,;
 {"LightYellow2",         "238 238 209"} ,;
 {"LightYellow3",         "205 205 180"} ,;
 {"LightYellow4",         "139 139 122"} ,;
 {"Yellow1",              "255 255 000"} ,;
 {"Yellow2",              "238 238 000"} ,;
 {"Yellow3",              "205 205 000"} ,;
 {"Yellow4",              "139 139 000"} ,;
 {"Gold1",                "255 215 000"} ,;
 {"Gold2",                "238 201 000"} ,;
 {"Gold3",                "205 173 000"} ,;
 {"Gold4",                "139 117 000"} ,;
 {"Goldenrod1",           "255 193 037"} ,;
 {"Goldenrod2",           "238 180 034"} ,;
 {"Goldenrod3",           "205 155 029"} ,;
 {"Goldenrod4",           "139 105 020"} ,;
 {"DarkGoldenrod1",       "255 185 015"} ,;
 {"DarkGoldenrod2",       "238 173 014"} ,;
 {"DarkGoldenrod3",       "205 149 012"} ,;
 {"DarkGoldenrod4",       "139 101 008"} ,;
 {"RosyBrown1",           "255 193 193"} ,;
 {"RosyBrown2",           "238 180 180"} ,;
 {"RosyBrown3",           "205 155 155"} ,;
 {"RosyBrown4",           "139 105 105"} ,;
 {"IndianRed1",           "255 106 106"} ,;
 {"IndianRed2",           "238 099 099"} ,;
 {"IndianRed3",           "205 085 085"} ,;
 {"IndianRed4",           "139 058 058"} ,;
 {"Sienna1",              "255 130 071"} ,;
 {"Sienna2",              "238 121 066"} ,;
 {"Sienna3",              "205 104 057"} ,;
 {"Sienna4",              "139 071 038"} ,;
 {"Burlywood1",           "255 211 155"} ,;
 {"Burlywood2",           "238 197 145"} ,;
 {"Burlywood3",           "205 170 125"} ,;
 {"Burlywood4",           "139 115 085"} ,;
 {"Wheat1",               "255 231 186"} ,;
 {"Wheat2",               "238 216 174"} ,;
 {"Wheat3",               "205 186 150"} ,;
 {"Wheat4",               "139 126 102"} ,;
 {"Tan1",                 "255 165 079"} ,;
 {"Tan2",                 "238 154 073"} ,;
 {"Tan3",                 "205 133 063"} ,;
 {"Tan4",                 "139 090 043"} ,;
 {"Chocolate1",           "255 127 036"} ,;
 {"Chocolate2",           "238 118 033"} ,;
 {"Chocolate3",           "205 102 029"} ,;
 {"Chocolate4",           "139 069 019"} ,;
 {"Firebrick1",           "255 048 048"} ,;
 {"Firebrick2",           "238 044 044"} ,;
 {"Firebrick3",           "205 038 038"} ,;
 {"Firebrick4",           "139 026 026"} ,;
 {"Brown1",               "255 064 064"} ,;
 {"Brown2",               "238 059 059"} ,;
 {"Brown3",               "205 051 051"} ,;
 {"Brown4",               "139 035 035"} ,;
 {"Salmon1",              "255 140 105"} ,;
 {"Salmon2",              "238 130 098"} ,;
 {"Salmon3",              "205 112 084"} ,;
 {"Salmon4",              "139 076 057"} ,;
 {"LightSalmon1",         "255 160 122"} ,;
 {"LightSalmon2",         "238 149 114"} ,;
 {"LightSalmon3",         "205 129 098"} ,;
 {"LightSalmon4",         "139 087 066"} ,;
 {"Orange1",              "255 165 000"} ,;
 {"Orange2",              "238 154 000"} ,;
 {"Orange3",              "205 133 000"} ,;
 {"Orange4",              "139 090 000"} ,;
 {"DarkOrange1",          "255 127 000"} ,;
 {"DarkOrange2",          "238 118 000"} ,;
 {"DarkOrange3",          "205 102 000"} ,;
 {"DarkOrange4",          "139 069 000"} ,;
 {"Coral1",               "255 114 086"} ,;
 {"Coral2",               "238 106 080"} ,;
 {"Coral3",               "205 091 069"} ,;
 {"Coral4",               "139 062 047"} ,;
 {"Tomato1",              "255 099 071"} ,;
 {"Tomato2",              "238 092 066"} ,;
 {"Tomato3",              "205 079 057"} ,;
 {"Tomato4",              "139 054 038"} ,;
 {"OrangeRed1",           "255 069 000"} ,;
 {"OrangeRed2",           "238 064 000"} ,;
 {"OrangeRed3",           "205 055 000"} ,;
 {"OrangeRed4",           "139 037 000"} ,;
 {"Red1",                 "255 000 000"} ,;
 {"Red2",                 "238 000 000"} ,;
 {"Red3",                 "205 000 000"} ,;
 {"Red4",                 "139 000 000"} ,;
 {"DeepPink1",            "255 020 147"} ,;
 {"DeepPink2",            "238 018 137"} ,;
 {"DeepPink3",            "205 016 118"} ,;
 {"DeepPink4",            "139 010 080"} ,;
 {"HotPink1",             "255 110 180"} ,;
 {"HotPink2",             "238 106 167"} ,;
 {"HotPink3",             "205 096 144"} ,;
 {"HotPink4",             "139 058 098"} ,;
 {"Pink1",                "255 181 197"} ,;
 {"Pink2",                "238 169 184"} ,;
 {"Pink3",                "205 145 158"} ,;
 {"Pink4",                "139 099 108"} ,;
 {"LightPink1",           "255 174 185"} ,;
 {"LightPink2",           "238 162 173"} ,;
 {"LightPink3",           "205 140 149"} ,;
 {"LightPink4",           "139 095 101"} ,;
 {"PaleVioletRed1",       "255 130 171"} ,;
 {"PaleVioletRed2",       "238 121 159"} ,;
 {"PaleVioletRed3",       "205 104 137"} ,;
 {"PaleVioletRed4",       "139 071 093"} ,;
 {"Maroon1",              "255 052 179"} ,;
 {"Maroon2",              "238 048 167"} ,;
 {"Maroon3",              "205 041 144"} ,;
 {"Maroon4",              "139 028 098"} ,;
 {"VioletRed1",           "255 062 150"} ,;
 {"VioletRed2",           "238 058 140"} ,;
 {"VioletRed3",           "205 050 120"} ,;
 {"VioletRed4",           "139 034 082"} ,;
 {"Magenta1",             "255 000 255"} ,;
 {"Magenta2",             "238 000 238"} ,;
 {"Magenta3",             "205 000 205"} ,;
 {"Magenta4",             "139 000 139"} ,;
 {"Orchid1",              "255 131 250"} ,;
 {"Orchid2",              "238 122 233"} ,;
 {"Orchid3",              "205 105 201"} ,;
 {"Orchid4",              "139 071 137"} ,;
 {"Plum1",                "255 187 255"} ,;
 {"Plum2",                "238 174 238"} ,;
 {"Plum3",                "205 150 205"} ,;
 {"Plum4",                "139 102 139"} ,;
 {"MediumOrchid1",        "224 102 255"} ,;
 {"MediumOrchid2",        "209 095 238"} ,;
 {"MediumOrchid3",        "180 082 205"} ,;
 {"MediumOrchid4",        "122 055 139"} ,;
 {"DarkOrchid1",          "191 062 255"} ,;
 {"DarkOrchid2",          "178 058 238"} ,;
 {"DarkOrchid3",          "154 050 205"} ,;
 {"DarkOrchid4",          "104 034 139"} ,;
 {"Purple1",              "155 048 255"} ,;
 {"Purple2",              "145 044 238"} ,;
 {"Purple3",              "125 038 205"} ,;
 {"Purple4",              "085 026 139"} ,;
 {"MediumPurple1",        "171 130 255"} ,;
 {"MediumPurple2",        "159 121 238"} ,;
 {"MediumPurple3",        "137 104 205"} ,;
 {"MediumPurple4",        "093 071 139"} ,;
 {"Thistle1",             "255 225 255"} ,;
 {"Thistle2",             "238 210 238"} ,;
 {"Thistle3",             "205 181 205"} ,;
 {"Thistle4",             "139 123 139"} ,;
 {"Grey11",               "028 028 028"} ,;
 {"Grey21",               "054 054 054"} ,;
 {"Grey31",               "079 079 079"} ,;
 {"Grey41",               "105 105 105"} ,;
 {"Grey51",               "130 130 130"} ,;
 {"Grey61",               "156 156 156"} ,;
 {"Grey71",               "181 181 181"} ,;
 {"Grey81",               "207 207 207"} ,;
 {"Grey91",               "232 232 232"} ,;
 {"DarkGrey",             "169 169 169"} ,;
 {"DarkBlue",             "000 000 139"} ,;
 {"DarkCyan",             "000 139 139"} ,;
 {"DarkMagenta",          "139 000 139"} ,;
 {"DarkRed",              "139 000 000"} ,;
 {"LightGreen",           "144 238 144"} }

/*     <------------ Optional Create "colors.ch"
Text := ""
FOR i = 1 TO HMG_LEN (aClrData)
   cColor := aClrData [i] [2]
   cRGB := PADL( Token( cColor, " ", 1 ) ,3) +" , "+ PADL( Token( cColor, " ", 2 ) ,3) +" , "+ PADL( Token( cColor, " ", 3 ) ,3)
   Text := Text + "#xtranslate   " + PAD ("COLOR_"+ aClrData [i] [1], 20) +  "   =>   { "+ cRGB +" }" + HB_OsNewLine()
NEXT
HB_MemoWrit ("colors.ch", Text)
*/

Return aClrData

******************************************************************************************************************************************

#include "about.prg"
#include "viewpdf.prg"